Subject: bug#8938: make timeout and CTRL-C

From: Pádraig Brady <[email-masked]>
Date: Sun, 03 Jul 2011 00:38:10 +0100

On 02/07/11 22:38, Alan Curry wrote:
> =?ISO-8859-1?Q?P=E1draig_Brady?= writes:
>>
>> Given the above setsid make example (which hangs for 10s
>> ignoring Ctrl-C, I'm leaning towards `make` needing to
>> be more shell like, or at least forward the SIGINT etc.
>> to the job, and not assume jobs run in the foreground group).
> 
> I'm a little worried that you're focusing too much on make, which is just one
> way to demonstrate the problems of process group abuse.
> 
> This simple shell script:
> 
> #!/bin/sh
> timeout 12 sleep 10
> 
> is also nonresponsive to ^C for the same reason as the original makefile.
> 
> Are you going to argue that the shell is doing something wrong there too?

Oh good point.
The shell script above becomes the foreground group,
rather than the timeout command as is the case when started directly.
I guess there are good reasons for the shell not
to propagate signals down to its children.

So we're left with Paul's "--single" option
to support this, with the tradeoff that it
only signals the child but nothing below that.

cheers,
Pádraig.